(*************************************************************************
 *                                                                       *
 *                            ISDN fr Delphi                            *
 *                                                                       *
 *                              Version 2.0                              *
 *                                                                       *
 *************************************************************************
 *                    Copyright (c) Stefan Graf 1999                     *
 *                         All rights reserved.                          *
 *************************************************************************
 *                            stefangraf@bigfoot.com                     *
 *                      http://www.mistermusiker.com/graf                *
 *            http://ourworld.compuserve.com/homepages/stefangraf        *
 *************************************************************************
 * $Revision: 1.2 $
 * $Name:  $
 * $Date: 1999-06-05 00:02:57+02 $
 *************************************************************************)
unit FaxTransfer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges, T30Protokoll, ComCtrls, ExtCtrls;

type
  TFaxTransfer = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Timer1: TTimer;
    Label7: TLabel;
    Label8: TLabel;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    StartTime     : DWORD;
    fFaxProtokoll : TT30Protokoll;
    fAbort        : TNotifyEvent;

    procedure SetFaxProtokoll (Protokoll : TT30Protokoll);
    procedure FaxTransferData  (Sender: TObject);
    procedure FaxTransferStart (Sender: TObject);
    procedure FaxTransferStop  (Sender: TObject);
    procedure FaxTransferAbort (Sender: TObject);
  public
    property FaxProtokoll : TT30Protokoll read fFaxProtokoll write SetFaxProtokoll;
    property Abort        : TNotifyEvent  read fAbort        write fAbort;

    procedure Rufannahme;
    procedure Anwahl;
    procedure Aufbau;
    procedure Abbau;
    procedure Ende;
  end;

implementation

{$R *.DFM}

procedure TFaxTransfer.SetFaxProtokoll (Protokoll : TT30Protokoll);
begin
  fFaxProtokoll := Protokoll;

  fFaxProtokoll.FaxTransferData  := FaxTransferData;
  fFaxProtokoll.FaxTransferStart := FaxTransferStart;
  fFaxProtokoll.FaxTransferStop  := FaxTransferStop;
  fFaxProtokoll.FaxTransferAbort := FaxTransferAbort;
end;

procedure TFaxTransfer.Rufannahme;
begin
  if (Owner <> nil) and (Owner is TControl) then begin
    Top := TControl(Owner).Top + (TControl(Owner).Height - Height) div 2;
    Left := TControl(Owner).Left + (TControl(Owner).Width - Width) div 2;
  end;

  StartTime := GetTickCount;
  ProgressBar1.Visible := false;
  Label1.Caption := '';
  Label3.Caption := '';
  Label6.Caption := '';
  Label8.Caption := '';
  StatusBar1.Panels [0].Text := 'Anruf erkannt ....';
  Visible := true;
  Timer1.Enabled := true;
end;

procedure TFaxTransfer.Anwahl;
begin
  if (Owner <> nil) and (Owner is TControl) then begin
    Top := TControl(Owner).Top + (TControl(Owner).Height - Height) div 2;
    Left := TControl(Owner).Left + (TControl(Owner).Width - Width) div 2;
  end;

  StartTime := GetTickCount;
  ProgressBar1.Visible := false;
  Label1.Caption := '';
  Label3.Caption := '';
  Label6.Caption := '';
  Label8.Caption := '';
  StatusBar1.Panels [0].Text := 'Anwahl ....';
  Visible := true;
  Timer1.Enabled := true;
end;

procedure TFaxTransfer.Aufbau;
begin
  StatusBar1.Panels [0].Text := 'Verbindungsaufbau ....';
end;

procedure TFaxTransfer.Abbau;
begin
  ProgressBar1.Visible := false;
  StatusBar1.Panels [0].Text := 'Verbindungsabbau ...';
end;

procedure TFaxTransfer.Ende;
begin
  Timer1.Enabled := false;
  Visible := false;
end;

procedure TFaxTransfer.FaxTransferData(Sender: TObject);
begin
  with Sender as TT30Protokoll do begin
    if (FaxMode = SendMode) then begin
      Label1.Caption  := IntToStr (SendBytes);
      ProgressBar1.Position := SendBytes;
    end else begin
      Label1.Caption := IntToStr (RecvBytes);
    end;
  end;
end;

procedure TFaxTransfer.FaxTransferStart(Sender: TObject);
begin
  with (Sender as TT30Protokoll) do begin
    Label6.Caption := Copy (FaxRecvInfo.RecevierID,1,25);

    if (FaxRecvInfo.Baudrate <> 0) then
      Label8.Caption := IntToStr (FaxRecvInfo.Baudrate)
    else Label8.Caption := '?';


    if (FaxMode = SendMode) then begin
      StatusBar1.Panels [0].Text := 'Senden ...';
      Label3.Caption  := IntToStr (SendSize);
      ProgressBar1.Max := SendSize;
      ProgressBar1.Visible := true;
    end else begin
      StatusBar1.Panels [0].Text := 'Empfangen ...';
    end;
  end;

  Visible := true;
end;

procedure TFaxTransfer.FaxTransferStop(Sender: TObject);
begin
  with (Sender as TT30Protokoll) do begin
    ProgressBar1.Position := SendBytes;
  end;
  
  StatusBar1.Panels [0].Text := 'Ok';
end;

procedure TFaxTransfer.FaxTransferAbort(Sender: TObject);
begin
  StatusBar1.Panels [0].Text := 'Abbruch ...';
end;

procedure TFaxTransfer.Button1Click(Sender: TObject);
begin
  if Assigned (fAbort) then
    fAbort (Self);
end;

procedure TFaxTransfer.Timer1Timer(Sender: TObject);
var
  numstr   : String [10];
  timediff : DWORD;
begin
  if (Visible) then begin
    timediff := (GetTickCount - StartTime) div 1000;
    
    numstr := '';

    if ((timediff div 60) < 10) then
       numstr := numstr + '0';
    numstr := numstr + IntToStr (timediff div 60) + ':';

    if ((timediff mod 60) < 10) then
       numstr := numstr + '0';
    numstr := numstr + IntToStr (timediff mod 60);

    StatusBar1.Panels [2].Text := numstr;
  end;
end;

end.
