{$I-}
unit Talkmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Capi2Bas, Capi2han, Capi2Con, Capi2Typ, Wave, Law, StdCtrls,
  MPlayer, ExtCtrls {$IFDEF Win32} , ComCtrls {$ENDIF}, IniFiles, CapiProt,
  T30Protokoll;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Anrufbeantworter1: TMenuItem;
    Ein1: TMenuItem;
    Aus1: TMenuItem;
    CAPIDisplay: TMemo;
    ListBox1: TListBox;
    MsnNeu: TButton;
    MsnDel: TButton;
    ListBox2: TListBox;
    MediaPlayer1: TMediaPlayer;
    Label1: TLabel;
    Label2: TLabel;
    RingTimer: TTimer;
    Auflegen1: TMenuItem;
    CapiHandler: TCapi20Handler;
    Setup1: TMenuItem;
    StatusBar1: TStatusBar;
    T30Protokoll1: TT30Protokoll;

    function CapiHandlerRing(Sender: TObject;const CallDaten : TCallDaten) : Cardinal;
    procedure Exit1Click(Sender: TObject);
    procedure Ein1Click(Sender: TObject);
    procedure Aus1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy (Sender: TObject);
    procedure CapiHandlerMessageDump(Sender: TObject; const CommandID,
      SubCommand: Cardinal; var Daten: ReceiveDatenType);
    procedure CapiHandlerReceive(Sender: TObject; const NCCI:LongInt;
      const Count: Cardinal);
    procedure CapiHandlerBConnect(Sender: TObject; const NCCI: LongInt);
    procedure CapiHandlerBDisconnect(Sender: TObject; const NCCI: Longint;
    const Grund: Cardinal);
    procedure CapiHandlerDisconnect(Sender: TObject;
      const Grund: Cardinal);
    procedure CapiHandlerError(Sender: TObject; const CommandID,
      SubCommand, ErrorNumber: Cardinal);
    procedure ListBox1DblClick(Sender: TObject);
    procedure MsnNeuClick(Sender: TObject);
    procedure MsnDelClick(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OnRingTimer(Sender: TObject);
    procedure CapiHandlerReceiveDTMF(Sender: TObject; const Taste: Char);
    procedure Auflegen1Click(Sender: TObject);
    procedure MediaPlayer1Click(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure CapiHandlerSetBProtokollEvent(Sender: TObject;
      var ProtokollParam: CapiBProtocolType);
    procedure Button1Click(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
  private
    abKanal : BKanalType;

    CodeStr    : String;
    CodeIdx    : Integer;
    CodeStatus : Cardinal;
    SkipPlay   : Integer;

    RufAnnahme : Boolean;
    AntwortFile : File;
    PlayStop,
    AntwortOpen : boolean;
    AnrufIndex : Integer;
    MaxDauer,
    RingDauer,
    AnswerWait,
    AntwortDauer : DWORD;
    PlayIndex : Integer;
    Anrufe : TStringList;

    LastCallReturn : Cardinal;
    LastCallDaten : TCallDaten;

    procedure PlayMessages (var Msg : TMessage); message WM_USER;
    procedure AnrufAufzeichen (var Msg : TMessage); message WM_USER + 1;

    procedure PlayWave (const Kanal : BKanalType; const FileName : String);
    procedure CheckCall;

    function ReadConfig : Integer;
    function SaveConfig : Integer;

    function GetFileName (const Index : Integer) : String;
    function ConvertLawToWave (const LawFileName, WaveFileName : String) : Integer;

    procedure PlayAnruf;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses TalkSetup;

{$R *.DFM}

type
  ByteArray     = array [0..$fff0] of Byte;
  SmallIntArray = array [0..$7ff0] of SmallInt;

var LastTempNr : Cardinal;

function GetTempFile (const DirName, ExtName : String) : String;
var path : String;
begin
  path := DirName;
  if (Length (path) > 0) and (path [Length (path)] <> '\') then path := path + '\';

  while (LastTempNr < 99999999) and FileExists (path + IntToStr (LastTempNr) + '.' + ExtName) do
    Inc (LastTempNr);

  if (LastTempNr > 99999999) then
    GetTempFile := ''
  else GetTempFile := path + IntToStr (LastTempNr) + '.' + ExtName;
end;

function TForm1.GetFileName (const Index : Integer) : String;
var
  line     : String;
  startpos : Cardinal;
begin
  line := Anrufe [Index];
  startpos := Pos (';',line);
  Delete (line,1,startpos);
  GetFileName := Copy (line,1,Pos (';',line) - 1);
end;

procedure TForm1.PlayWave (const Kanal : BKanalType; const FileName : String);
var
  i,
  readanz : Integer;
  outbuf   : ^ByteArray;
  inbuf  : ^SmallIntArray;
  wave    : TWave;
begin
  GetMem (outbuf, 2048 * sizeof (byte));
  GetMem (inbuf, 4096 * sizeof (SmallInt));

  wave := TWave.Create;
  PlayStop := false;
  if (wave.Open (FileName) = 0) then begin
    repeat
      readanz := wave.Read (inbuf^,CapiHandler.BDataBlockSize);

      if (readanz > 0) then begin
        for i:=0 to (readanz - 1) do
          outbuf^[i] := IntToLaw (inbuf^[i]);

        CapiHandler.Write (Kanal, outbuf^, readanz);
      end;
    until (PlayStop) or (readanz <= 0) or (CapiHandler.GetConnectStatus <> ConnectB);

    wave.Close;
  end;

  CapiHandler.Flush (Kanal);

  wave.Destroy;

  FreeMem (outbuf, 2048 * sizeof (byte));
  FreeMem (inbuf, 4096 * sizeof (SmallInt));
end;

procedure TForm1.PlayMessages (var Msg : TMessage);
var
  idx,
  readanz : Integer;
  buf     : ^ByteArray;
  filevar : File;
begin
  GetMem (buf, 4096);
  idx := 0;

  PlayWave (abKanal, 'first.wav');

  repeat
    SkipPlay := 0;

    AssignFile (filevar, GetFileName (idx));
    Reset (filevar,1);
    if (IOResult = 0) then begin
      repeat
        BlockRead (filevar,buf^,CapiHandler.BDataBlockSize, readanz);

        if (IOResult <> 0) then
          readanz := -1;

        if (readanz > 0) then begin
          CapiHandler.Write (abKanal, buf^, readanz);
        end;
      until (SkipPlay <> 0) or (readanz <= 0) or (CapiHandler.GetConnectStatus <> ConnectB);

      CloseFile (filevar);
    end;

    if (SkipPlay >= 0) then begin
      Inc (idx);
      PlayWave (abKanal, 'next.wav');
    end else begin
      if (idx = 0) then
        PlayWave (abKanal, 'first.wav');
      begin
        Dec (idx);
        PlayWave (abKanal, 'prev.wav');
      end;
    end;
  until ((idx >= Anrufe.Count) or (CapiHandler.GetConnectStatus <> ConnectB));

  PlayWave (abKanal, 'last.wav');

  FreeMem (buf, 4096);
end;

procedure TForm1.AnrufAufzeichen (var Msg : TMessage);
var fname   : String;
begin
  PlayWave (abKanal,'ansage.wav');

  PlayWave (abKanal,'beep.wav');

  AntwortDauer := GetTickCount;

  fname := GetTempFile ('','law');

  if (Length (fname) > 0) then begin
    Anrufe [AnrufIndex] := Anrufe [AnrufIndex] + ';' + fname;

    AssignFile (AntwortFile,fname);
    Rewrite (AntwortFile,1);
    if (IOResult = 0) then
      AntwortOpen := true;
  end;
end;

procedure TForm1.CapiHandlerBConnect(Sender: TObject; const NCCI: LongInt);
begin
  CodeIdx := 1;
  CodeStatus := 0;
  abKanal := NCCI;

  PostMessage (Handle, wm_user + 1, 0, 0);
end;

procedure TForm1.CheckCall;
var
  i       : Integer;
  found   : Boolean;
  numstr  : String [26];
  line    : String;
  nowtime : TDateTime;
begin
  with LastCallDaten do begin
    line := Copy (CallFrom,3,Length (CallFrom) - 2);
    line := line + ' fr ' + Copy (CallTo,2,Length (CallTo) - 1);

    if not (Service in [ANALOG_TELEPHONY, DIGITAL_TELEPHONY]) then
      LastCallReturn := IGNORE_CALL
    else begin
      i := 0;
      found := false;
      numstr := Copy (CallTo,2,Length (CallTo) - 1);

      while not (found) and (i < ListBox1.Items.Count) do begin
        if (ListBox1.Items [i] = numstr) then
          found := true
        else Inc (i);
      end;

      if not (found) then
        LastCallReturn := IGNORE_CALL
      else begin
        nowtime := Now;
        line := DateToStr (nowtime) + ' ' + TimeToStr (nowtime);
        line := line + ' : Anruf von ';
        if (Length (CallFrom) = 0) then
          line := line + 'unbekannt'
        else if (CallFrom [2] = #$A0) then
          line := line + 'anonym'
        else line := line + Copy (CallFrom,3,Length (CallFrom) - 2);

        line := line + ' fr ' + Copy (CallTo,2,Length (CallTo) - 1);

        AnrufIndex := Anrufe.Add (line);
        ListBox2.Items.Insert (AnrufIndex,Anrufe [AnrufIndex]);

        LastCallReturn := ACCEPT_CALL;
      end;
    end;
  end;
end;

function TForm1.CapiHandlerRing(Sender: TObject;const CallDaten : TCallDaten) : Cardinal;
begin
  LastCallReturn := IGNORE_CALL;
  LastCallDaten := CallDaten;

  with Sender as TCapi20Handler do begin
    {$IFDEF Win32}
      Synchronize (CheckCall);
    {$ELSE}
      CheckCall;
    {$ENDIF}

    if (LastCallReturn <> ACCEPT_CALL) then
      CapiHandlerRing := LastCallReturn
    else begin
      EnableListen ([]);

      B1Protokol := TRANS_64K;
      B2Protokol := BITTRANS;
      B3Protokol := B3_TRANSPARENT;

      AnswerWait := GetTickCount + RingDauer * 1000;

      CapiHandlerRing := WAIT_ACCEPT_CALL
    end;
  end;
end;

procedure TForm1.CapiHandlerReceive(Sender: TObject; const NCCI : LongInt; const Count: Cardinal);
var
  readanz : Cardinal;
  buf : array [0..4096] of char;
begin
  readanz := CapiHandler.Read (abKanal, buf,Count);

  if (AntwortOpen) then begin
    BlockWrite (AntwortFile,buf,readanz);

    if (IOResult <> 0) then;
  end;
end;

procedure TForm1.CapiHandlerDisconnect(Sender: TObject; const Grund: Cardinal);
begin
  AnswerWait := 0;
  AntwortDauer := GetTickCount - AntwortDauer;

  if (AnrufIndex <> -1) then
    Anrufe [AnrufIndex] := Anrufe [AnrufIndex] + ';' + IntToStr (AntwortDauer);

  AnrufIndex := -1;

  AntwortOpen := False;
  
  if RufAnnahme then
    CapiHandler.EnableListen ([ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  if CapiHandler.ApplicationRegistered then
    CapiHandler.EnableListen ([]);

  Close;
end;

procedure TForm1.Ein1Click(Sender: TObject);
begin
  if not (CapiHandler.ApplicationRegistered) then
    MessageDLG ('CAPI nicht verfgbar', mtWarning, [mbOK], 0)
  else begin
    RufAnnahme := true;

    CapiHandler.EnableListen ([ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
  end;
end;

procedure TForm1.Aus1Click(Sender: TObject);
begin
  if not (CapiHandler.ApplicationRegistered) then
    MessageDLG ('CAPI nicht verfgbar', mtWarning, [mbOK], 0)
  else begin
    RufAnnahme := false;

    CapiHandler.EnableListen ([]);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i      : Integer;
  start,
  strpos : Integer;
  line   : String;
  IniDaten : TIniFile;
begin
  Anrufe := TStringList.Create;
  CodeIdx := 0;
  PlayIndex := -1;

  IniDaten := TIniFile.Create ('ISDNTalk.in');
  CodeStr := IniDaten.ReadString ('Setup','AbfrageCode', '0000');
  MaxDauer := StrToInt (IniDaten.ReadString('Setup','MaxDauer', '30'));
  if (MaxDauer = 0) then
    MaxDauer := 30;
  RingDauer := StrToInt (IniDaten.ReadString('Setup','RingDauer', '3'));
  if (RingDauer = 0) then
    RingDauer := 3;
  IniDaten.Destroy;

  if (FileExists ('anrufe.dat')) then begin
    Anrufe.LoadFromFile ('anrufe.dat');

    if (Anrufe.Count > 0) then begin
      for i:=0 to Anrufe.Count - 1 do begin
        line := Anrufe [i];

        strpos := Pos (';',line);
        start := strpos;
        Inc (strpos);
        while (strpos <= Length (line)) and (line [strpos] <> ';') do Inc (strpos);
        Delete (line,start,(strpos - start) + 1);

        ListBox2.Items.Insert (i,line);
      end;
    end;
  end;

  CapiHandler.BDataBlockSize := 2048;

  RufAnnahme  := false;
  AntwortOpen := false;
  AnrufIndex  := -1;

  ListBox1.Items.Clear;
  ReadConfig;

  if CapiHandler.CapiAvailable and not (CapiHandler.ApplicationRegistered) then
    CapiHandler.RegisterApplication;
end;

procedure TForm1.CapiHandlerMessageDump(Sender: TObject; const CommandID,
  SubCommand: Cardinal; var Daten: ReceiveDatenType);
begin
  if (CommandID <> DATA_B3) then
    CAPIDisplay.Lines.Add (CapiHandler.GetCommandStr (CommandID,SubCommand));
end;

procedure TForm1.CapiHandlerBDisconnect(Sender: TObject; const NCCI : LongInt; const Grund: Cardinal);
begin
  if (AntwortOpen) then
    CloseFile (AntwortFile);

  AntwortOpen := false;
end;

procedure TForm1.CapiHandlerError(Sender: TObject; const CommandID,
  SubCommand, ErrorNumber: Cardinal);
begin
  if (CommandID = 0) then
    MessageDLG (CapiHandler.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0)
  else
    MessageDLG (CapiHandler.GetCommandStr (CommandID,SubCommand) + ' : ' +
    CapiHandler.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0);
end;

procedure TForm1.FormDestroy (Sender: TObject);
begin
  if (Anrufe <> Nil) then begin
    Anrufe.SaveToFile ('anrufe.dat');

    Anrufe.Destroy;
  end;

  if (CapiHandler <> Nil) then begin
    if CapiHandler.ApplicationRegistered then
      CapiHandler.ReleaseApplication;
  end;
end;

function TForm1.ReadConfig : Integer;
var
  line    : String;
  auswahl : Cardinal;
  cfgfile : TextFile;
begin
  AssignFile (cfgfile,'anruf.ini');
  Reset (cfgfile);
  if (IOResult <> 0) then
    ReadConfig := -1
  else begin
    auswahl := 0;
    ListBox1.Items.Clear;

    while not (Eof (cfgfile)) do begin
      ReadLn (cfgfile,line);
      if (line [1] = '[') then begin
        if (Pos ('[LISTEN_MSN]',line) <> 0) then
          auswahl := 1;
      end else begin
        case auswahl of
          1 : ListBox1.Items.Add (line);
        end;
      end;
    end;

    CloseFile (cfgfile);

    ReadConfig := 0;
  end;
end;

function TForm1.SaveConfig : Integer;
var
  i       : Cardinal;
  cfgfile : TextFile;
begin
  AssignFile (cfgfile,'anruf.ini');
  Rewrite (cfgfile);
  if (IOResult <> 0) then
    SaveConfig := -1
  else begin
    WriteLn (cfgfile,'[LISTEN_MSN]');

    for i:=0 to (ListBox1.Items.Count - 1) do
      WriteLn (cfgfile,ListBox1.Items [i]);

    CloseFile (cfgfile);

    SaveConfig := 0;
  end;
end;
procedure TForm1.ListBox1DblClick(Sender: TObject);
var numstr : String [26];
begin
  if (ListBox1.ItemIndex <> -1) then begin
    numstr := InputBox ('Telefonnummer','Rufnummer ndern',ListBox1.Items [ListBox1.ItemIndex]);
    if (ListBox1.Items [ListBox1.ItemIndex] <> numstr) then begin
      ListBox1.Items [ListBox1.ItemIndex] := numstr;

      SaveConfig;
    end;
  end;
end;

procedure TForm1.MsnNeuClick(Sender: TObject);
var numstr : String [26];
begin
  numstr := InputBox ('Telefonnummer','Neue Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    ListBox1.Items.Add (numstr);

    SaveConfig;
  end;
end;

procedure TForm1.MsnDelClick(Sender: TObject);
begin
  if (ListBox1.ItemIndex <> -1) then begin
    ListBox1.Items.Delete (ListBox1.ItemIndex);

    SaveConfig;
  end;
end;

procedure TForm1.PlayAnruf;
begin
  if (MediaPlayer1.DeviceID <> 0) then begin
    MediaPlayer1.Stop;
    MediaPlayer1.Close;
  end;

  if (ConvertLawToWave (GetFileName (PlayIndex),'tmp.wav') <> 0) then
    MessageDLG ('Anruftext nicht vorhanden, oder nicht lesbar', mtWarning, [mbOK], 0)
  else begin
    MediaPlayer1.FileName := 'tmp.wav';
    MediaPlayer1.Open;

    if (MediaPlayer1.Error <> 0) then
      MessageDLG (MediaPlayer1.ErrorMessage, mtWarning, [mbOK], 0)
    else begin
      MediaPlayer1.Play;
    end;
  end;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
  if (ListBox2.ItemIndex <> -1) then begin
    PlayIndex := ListBox2.ItemIndex;
    PlayAnruf;
  end;
end;

function TForm1.ConvertLawToWave (const LawFileName, WaveFileName : String) : Integer;
var
  outidx    : Cardinal;
  wert      : Integer;
  wave      : TWave;
  inbuf     : ^ByteArray;
  outbuf    : ^SmallIntArray;
  i,
  readanz   : Cardinal;
  filevar   : File;
begin
  GetMem (inbuf, 2048 * sizeof (byte));
  GetMem (outbuf, 4096 * sizeof (SmallInt));
  wave := TWave.Create;

  AssignFile (filevar, LawFileName);

  Reset (filevar,1);
  if (IOResult <> 0) then
    ConvertLawToWave := -1
  else begin
    wave.SetFormat (1,8000,Bit_16);

    if (wave.Build (WaveFileName) <> 0) then
      ConvertLawToWave := -2
    else begin
      repeat
        BlockRead (filevar, inbuf^[0], 2048, readanz);

        if (IOResult <> 0) then
          readanz := 0
        else begin
          if (readanz > 0) then begin
            outidx := 0;
            for i:= 0 to (readanz - 1) do begin
              wert := LawToInt (inbuf^[i]);

              outbuf^[outidx] := wert;
              Inc (outidx);
            end;
            wave.Write (outbuf^,readanz);
          end;
        end;
      until (readanz = 0);

      ConvertLawToWave := 0;

      wave.Close;
    end;

    CloseFile (filevar);
  end;

  wave.Destroy;
  FreeMem (inbuf, 2048 * sizeof (byte));
  FreeMem (outbuf, 4096 * sizeof (SmallInt));
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var numstr : String [20];
begin
  if (ListBox1.ItemIndex <> -1) then begin
    if (Key = VK_DELETE) then begin
      if (MessageDLG ('Nummer wirklich lschen', mtConfirmation, [mbCancel,mbOK], 0) = mrOK) then begin
        ListBox1.Items.Delete (ListBox1.ItemIndex);

        SaveConfig;
      end;
    end else if (Key = VK_INSERT) then begin
      numstr := InputBox ('Telefonnummer','Neue Rufnummer eingeben','');
      if (Length (numstr) > 0) then begin
        ListBox1.Items.Add (numstr);

        SaveConfig;
      end;
    end;
  end;
end;

procedure TForm1.ListBox2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var tmpstr : array [0..128] of char;  
begin
  if (ListBox2.ItemIndex <> -1) then begin
    if (Key = VK_DELETE) then begin
      if (MessageDLG ('Eintrag wirklich lschen', mtConfirmation, [mbCancel,mbOK], 0) = mrOK) then begin
        {$IFDEF Win32}
          DeleteFile (StrPCopy (tmpstr, GetFileName (ListBox2.ItemIndex)));
        {$ELSE}
          DeleteFile (GetFileName (ListBox2.ItemIndex));
        {$ENDIF}
        Anrufe.Delete (ListBox2.ItemIndex);
        ListBox2.Items.Delete (ListBox2.ItemIndex);
      end;
    end;
  end;
end;

procedure TForm1.MediaPlayer1Click (Sender: TObject; Button: TMPBtnType;
  var DoDefault: Boolean);
begin
  if (Button = TMPBtnType (btNext)) then begin
    DoDefault := false;

    if (PlayIndex < (Anrufe.Count - 1)) then begin
      Inc (PlayIndex);
      ListBox2.ItemIndex := PlayIndex;
      PlayAnruf;
    end;
 end else if (Button = TMPBtnType (btPrev)) then begin
    DoDefault := false;

    if (PlayIndex > 0) then begin
      Dec (PlayIndex);
      ListBox2.ItemIndex := PlayIndex;
      PlayAnruf;
    end;
  end else DoDefault := true;
end;

procedure TForm1.OnRingTimer(Sender: TObject);
var time : LongInt;
begin
  if (AnswerWait <> 0) then begin
    if (GetTickCount > AnswerWait) then begin
      AnswerWait := 0;
      CapiHandler.AnswerCall (ACCEPT_CALL);
    end;
  end;

  if (AntwortOpen) then begin
    time := (GetTickCount - AntwortDauer) div 1000;
    StatusBar1.Panels [1].Text := IntToStr (time div 60) + ':' + IntToStr (time mod 60);

    if (CodeStatus = 0) and (time > MaxDauer) then
      CapiHandler.DisconnectLine (0);
  end;
end;

procedure TForm1.CapiHandlerReceiveDTMF(Sender: TObject;
  const Taste: Char);
begin
  if (CodeStatus = 0) then begin
    if (CodeStr [CodeIdx] <> taste) then
      CodeIdx := 1
    else begin
      Inc (CodeIdx);
      if (CodeIdx > Length (CodeStr)) then begin
        PlayStop := true;
        CodeStatus := 1;
        PostMessage (Handle,WM_USER, 0, 0);
      end;
    end;
  end else if (CodeStatus = 1) then begin
    if (taste = '*') then begin
      SkipPlay := -1;
      PlayStop := true;
    end else if (taste = '#') then begin
      SkipPlay := 1;
      PlayStop := true;
    end;
  end;

  CAPIDisplay.Lines.Add ('DTMF : ' + taste + '(' + IntToStr (CodeIdx) + ')');
end;

procedure TForm1.Auflegen1Click(Sender: TObject);
begin
  CapiHandler.DisconnectLine (0);
end;

procedure TForm1.CapiHandlerSetBProtokollEvent(Sender: TObject;
  var ProtokollParam: CapiBProtocolType);
begin
  with Sender as TCapi20Handler, ProtokollParam do begin
    if (B2Protokol = X75) then begin
      B2Configuration.Size       := 5;
      B2Configuration.LinkAdrA   := 3;
      B2Configuration.LinkAdrB   := $C1;
      B2Configuration.ModuloMode := 8;
      B2Configuration.WindowSize := 7;
    end else if (B2Protokol = SDLC) then begin
      B2Configuration.Size       := 5;
      B2Configuration.LinkAdrA   := $C1;
      B2Configuration.ModuloMode := 8;
      B2Configuration.WindowSize := 7;
{      B2Configuration.XID        := '';}
    end else if (B2Protokol = LAPD) then begin
      B2Configuration.Size       := 5;
      B2Configuration.LinkAdrA   := 0;
      B2Configuration.ModuloMode := 8;
      B2Configuration.WindowSize := 7;
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PlayWave (abKanal,'ansage.wav');
end;

procedure TForm1.Setup1Click(Sender: TObject);
var IniDaten : TIniFile;
begin
  SetupDialog.Edit1.Text := CodeStr;
  SetupDialog.UpDown1.Position := MaxDauer;
  SetupDialog.UpDown2.Position := RingDauer;

  if (SetupDialog.ShowModal = mrOk) then begin
    CodeStr := SetupDialog.Edit1.Text;
    MaxDauer := SetupDialog.UpDown1.Position;
    RingDauer := SetupDialog.UpDown2.Position;

    IniDaten := TIniFile.Create ('ISDNTalk.in');
    IniDaten.WriteString('Setup','AbfrageCode', CodeStr);
    IniDaten.WriteString('Setup','MaxDauer', IntToStr (MaxDauer));
    IniDaten.WriteString('Setup','RingDauer', IntToStr (RingDauer));
//    IniDaten.Updatefile;
    IniDaten.Destroy;
  end;
end;

begin
  LastTempNr := 0;
end.
