(*************************************************************************
 *                                                                       *
 *                            ISDN fr Delphi                            *
 *                                                                       *
 *                              Version 2.0                              *
 *                                                                       *
 *************************************************************************
 *                    Copyright (c) Stefan Graf 1999                     *
 *                         All rights reserved.                          *
 *************************************************************************
 *                            info@isdn-tools.de                         *
 *                         http://www.isdn-tools.de                      *
 *************************************************************************
 * $Revision: 1.1 $
 * $Date: 1999-04-26 20:35:41+02 $
 *************************************************************************)
unit ProtTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Capi2Bas, Capi2han, Capi2Typ, Capi2Con, CapiProt, StdCtrls, T30Protokoll;

type
  TForm1 = class(TForm)
    X25Protokoll1: TX25Protokoll;
    Memo1: TMemo;
    Button2: TButton;
    V110Protokoll1: TV110Protokoll;
    Memo2: TMemo;
    ModemProtokoll1: TModemProtokoll;
    GroupBox1: TGroupBox;
    TV110Button: TRadioButton;
    TV120Button: TRadioButton;
    TV12042Button: TRadioButton;
    TV120TransButton: TRadioButton;
    TModemButton: TRadioButton;
    V120Protokoll1: TV120Protokoll;
    Capi20Handler1: TCapi20Handler;
    X25Button: TRadioButton;
    X25DCEButton: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function Capi20Handler1Ring(Sender: TObject;
      const CallDaten: TCallDaten): Cardinal;
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
    procedure Capi20Handler1Receive(Sender: TObject; const NCCI: Longint;
      const Count: Cardinal);
    procedure Capi20Handler1BConnect(Sender: TObject; const NCCI: Longint);
    procedure Capi20Handler1Error(Sender: TObject; const CommandID,
      SubCommand, ErrorNumber: Cardinal);
    procedure Capi20Handler1MessageDump(Sender: TObject; const CommandID,
      SubCommand: Cardinal; var Daten: ReceiveDatenType);
    procedure FormDestroy(Sender: TObject);
  private
    IsOurs : Boolean;
    LastChar : Char;
    DatenKanal : BKanalType;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var data : CapiBProtocolType;
begin
  Capi20Handler1.DisconnectLine (0);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  numstr : String;
  res    : Boolean;
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    if (TV110Button.Checked) then begin
     Capi20Handler1.B1Protokol := V110_ASYNCH;
     Capi20Handler1.B2Protokol := BITTRANS;
     Capi20Handler1.B3Protokol := B3_TRANSPARENT;

     res := Capi20Handler1.Call (numstr,'',DATA_64K);
    end else if (TV120Button.Checked) then begin
     Capi20Handler1.B1Protokol := HDLC_64K;
     Capi20Handler1.B2Protokol := V120_ASYNCH;
     Capi20Handler1.B3Protokol := B3_TRANSPARENT;

     res := Capi20Handler1.Call (numstr,'',DATA_64K);
    end else if (TV12042Button.Checked) then begin
     Capi20Handler1.B1Protokol := HDLC_64K;
     Capi20Handler1.B2Protokol := V120_V42;
     Capi20Handler1.B3Protokol := B3_TRANSPARENT;

     res := Capi20Handler1.Call (numstr,'',DATA_64K);
    end else if (TV120TransButton.Checked) then begin
     Capi20Handler1.B1Protokol := HDLC_64K;
     Capi20Handler1.B2Protokol := V120_TRANSPARENT;
     Capi20Handler1.B3Protokol := B3_TRANSPARENT;

     res := Capi20Handler1.Call (numstr,'',DATA_64K);
    end else if (TModemButton.Checked) then begin
     Capi20Handler1.B1Protokol := ASYNCH_MODEM;
     Capi20Handler1.B2Protokol := B2_Modem;
     Capi20Handler1.B3Protokol := B3_Modem;

     res := Capi20Handler1.Call (numstr,'',DATA_64K);
    end else if (X25Button.Checked) then begin
     Capi20Handler1.B1Protokol := HDLC_64k;
     Capi20Handler1.B2Protokol := LAPD;
     Capi20Handler1.B3Protokol := ISO8208;

     res := Capi20Handler1.Call (numstr,'', PACKET_MODE);
    end else if (X25DCEButton.Checked) then begin
     Capi20Handler1.B1Protokol := HDLC_64k;
     Capi20Handler1.B2Protokol := LAPD;
     Capi20Handler1.B3Protokol := X25;

     res := Capi20Handler1.Call (numstr,'', PACKET_MODE);
    end;

    if not (res) then
     MessageDLG ('Fehler beim Call', mtError, [mbOK], 0);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  b1support, b2support, b3support : Cardinal;
begin
  IsOurs := false;

  with Capi20Handler1 do begin
   b1support := GetSupportedB1Protokoll (Controller);
   b2support := GetSupportedB2Protokoll (Controller);
   b3support := GetSupportedB3Protokoll (Controller);
 end;

 if ((b1support and $0004) <> 0) then
   TV110Button.Enabled := true;

 if ((b2support and $0200) <> 0) then
   TV120Button.Enabled := true;

 if ((b2support and $0400) <> 0) then
   TV12042Button.Enabled := true;

 if ((b2support and $0800) <> 0) then
   TV120TransButton.Enabled := true;

 if ((b1support and $0080) <> 0) and ((b2support and $0080) <> 0) and ((b3support and $0080) <> 0) then
   TModemButton.Enabled := true;

 if ((b1support and $0001) <> 0) and ((b2support and $0008) <> 0) and ((b3support and $0004) <> 0) then
   X25Button.Enabled := true;

 if ((b1support and $0001) <> 0) and ((b2support and $0008) <> 0) and ((b3support and $0008) <> 0) then
   X25DCEButton.Enabled := true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Capi20Handler1.EnableListen ([]);
end;

function TForm1.Capi20Handler1Ring(Sender: TObject;
  const CallDaten: TCallDaten): Cardinal;
var line : STring;
begin
  line := 'Ring (' + Copy (CallDaten.CallTo,2,128) + ') : ';
  if (Copy (CallDaten.CallTo,2,128) <> '22') then begin
    line := line + 'Ignore';
    Result := IGNORE_CALL;
  end else begin
    line := line + 'Accept';
    Result := ACCEPT_CALL;
  end;

  Memo1.Lines.Add (line);
end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (IsOurs) then begin
    LastChar := Key;
    Capi20Handler1.Write (DatenKanal,Key,sizeof (Key));
  End;
end;

procedure TForm1.Capi20Handler1Receive(Sender: TObject;
  const NCCI: Longint; const Count: Cardinal);
var
  CommChar:Char;
  i:Word;
begin
  IsOurs:=True;
  for i:=1 to Count do
  begin
    Capi20Handler1.Read(NCCI, CommChar, SizeOf(CommChar));
    if (CommChar <> LastChar) then begin
      LastChar := #0;

      if (CommChar <> #10) then
        SendMessage(Memo1.Handle,WM_CHAR,Word(CommChar),0);
    End;
  end;
  IsOurs:=False;
end;

procedure TForm1.Capi20Handler1BConnect(Sender: TObject;
  const NCCI: Longint);
begin
  DatenKanal := NCCI;
  Memo1.Clear;
  Memo1.SetFocus;
  IsOurs:=false;
end;

procedure TForm1.Capi20Handler1Error(Sender: TObject; const CommandID,
  SubCommand, ErrorNumber: Cardinal);
begin
  with (Sender as TCapi20Handler) do
    MessageDLG (GetCommandStr (CommandID,SubCommand) + ' : ' + GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0);
end;

procedure TForm1.Capi20Handler1MessageDump(Sender: TObject;
  const CommandID, SubCommand: Cardinal; var Daten: ReceiveDatenType);
begin
  with Sender as TCapi20Handler Do
    Memo2.Lines.Add (GetCommandStr (CommandID,SubCommand));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if (Capi20Handler1 <> Nil) then begin
    if Capi20Handler1.ApplicationRegistered then
      Capi20Handler1.ReleaseApplication;
  end;
end;

end.
