unit UmleitungMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Capi2Con, Capi2Typ, Capi2Bas, Capi2han, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    CapiVerbindung1: TCapi20Handler;
    CapiVerbindung2: TCapi20Handler;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Aktive1: TMenuItem;
    Ein1: TMenuItem;
    Aus1: TMenuItem;
    Setup1: TMenuItem;
    Nummer1: TMenuItem;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Weiterleiten1: TMenuItem;
    function CapiVerbindung1Ring(Sender: TObject;
      const CallDaten: TCallDaten): Cardinal;
    procedure CapiVerbindung1Receive(Sender: TObject; const NCCI: Integer;
      const Count: Cardinal);
    procedure CapiVerbindung2Receive(Sender: TObject; const NCCI: Integer;
      const Count: Cardinal);
    procedure CapiVerbindung2BConnect(Sender: TObject;
      const NCCI: Integer);
    procedure CapiVerbindung1BConnect(Sender: TObject;
      const NCCI: Integer);
    procedure Ein1Click(Sender: TObject);
    procedure Aus1Click(Sender: TObject);
    procedure Nummer1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CapiVerbindung1BDisconnect(Sender: TObject;
      const NCCI: Integer; const Grund: Cardinal);
    procedure CapiVerbindung2BDisconnect(Sender: TObject;
      const NCCI: Integer; const Grund: Cardinal);
    procedure CapiVerbindung1MessageDump(Sender: TObject; const CommandID,
      SubCommand: Cardinal; var Daten: ReceiveDatenType);
    procedure CapiVerbindung2MessageDump(Sender: TObject; const CommandID,
      SubCommand: Cardinal; var Daten: ReceiveDatenType);
    procedure Weiterleiten1Click(Sender: TObject);
    procedure CapiVerbindung1Disconnect(Sender: TObject;
      const Grund: Cardinal);
  private
    AnnahmeOk       : Boolean;
    AnnahmeNr,
    WeiterleitungNr : TCallNumber;
    DestNCCI,
    SourceNCCI      : BKanalType;

    WindowHandle : hWnd;
    procedure WinProc (var WndMessage:TMessage);
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.CapiVerbindung1Ring(Sender: TObject; const CallDaten: TCallDaten): Cardinal;
var numstr : TCallNumber;
begin
  numstr := Copy (CallDaten.CallTo,2,Length (CallDaten.CallTo) - 1);
  if (numstr <> AnnahmeNr) then
    CapiVerbindung1Ring := IGNORE_CALL
  else begin
    if (CallDaten.Service in [TELEPHONY, ANALOG_TELEPHONY, DIGITAL_TELEPHONY]) then begin
      CapiVerbindung1.EnableListen ([]);
      CapiVerbindung1Ring := ACCEPT_CALL;
    end else CapiVerbindung1Ring := IGNORE_CALL;
  end;
end;

procedure TForm1.CapiVerbindung1Receive(Sender: TObject;
  const NCCI: Integer; const Count: Cardinal);
var
  anz : Integer;
  buf : array [0..2048] of char;
begin
  if (CapiVerbindung2.GetConnectStatus = ConnectB) then begin
    anz := CapiVerbindung1.Read (SourceNCCI, buf, Count);
    if (anz > 0) then
      CapiVerbindung2.Write (DestNCCI, buf, anz);
  end;
end;

procedure TForm1.CapiVerbindung2Receive(Sender: TObject;
  const NCCI: Integer; const Count: Cardinal);
var
  anz : Integer;
  buf : array [0..2048] of char;
begin
  if (CapiVerbindung1.GetConnectStatus = ConnectB) then begin
    anz := CapiVerbindung2.Read (DestNCCI, buf, Count);
    if (anz > 0) then
      CapiVerbindung1.Write (SourceNCCI, buf, anz);
  end;
end;

procedure TForm1.CapiVerbindung2BConnect(Sender: TObject; const NCCI: Integer);
begin
  DestNCCI := NCCI;
  PostMessage (WindowHandle, WM_USER + 4, 0, 0);
end;

procedure TForm1.CapiVerbindung1BConnect(Sender: TObject; const NCCI: Integer);
begin
  SourceNCCI := NCCI;
  PostMessage (WindowHandle, WM_USER + 3, 0, 0);
end;

procedure TForm1.Ein1Click(Sender: TObject);
begin
  AnnahmeOk := true;
  CapiVerbindung1.EnableListen ([TELEPHONY, ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
end;

procedure TForm1.Aus1Click(Sender: TObject);
begin
  AnnahmeOk := false;
  CapiVerbindung1.EnableListen ([]);
end;

procedure TForm1.Nummer1Click(Sender: TObject);
var numstr : String;
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    AnnahmeNr := numstr;
    Form1.Caption := 'Rumfumleitung von ' + AnnahmeNr + ' nach ' + WeiterleitungNr;
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

{Der berladene Messagehandler fr das Verarbeiten der CAPI-Message}
procedure TForm1.WinProc (var WndMessage:TMessage);

begin
  with WndMessage do begin
    if (Msg = WM_USER + 1) then begin
      CheckBox2.Checked := false;
      CapiVerbindung1.DisconnectLine (0);
    end else if (Msg = WM_USER + 2) then begin
      CheckBox1.Checked := false;
      CapiVerbindung2.DisconnectLine (0);
    end else if (Msg = WM_USER + 3) then begin
      CheckBox1.Checked := true;
      CapiVerbindung2.Call (WeiterleitungNr, '', TELEPHONY);
    end else if (Msg = WM_USER + 4) then begin
      CheckBox2.Checked := true;
    end else begin
      Result:=DefWindowProc (WindowHandle,Msg,wParam,lParam)
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  AnnahmeOk := false;
  AnnahmeNr := '';
  WeiterleitungNr := '';

  Form1.Caption := 'Rumfumleitung von ' + AnnahmeNr + ' nach ' + WeiterleitungNr;

  WindowHandle := AllocateHWnd (WinProc);
end;

procedure TForm1.CapiVerbindung1BDisconnect(Sender: TObject;
  const NCCI: Integer; const Grund: Cardinal);
begin
  PostMessage (WindowHandle, WM_USER + 2, 0, 0);
end;

procedure TForm1.CapiVerbindung2BDisconnect(Sender: TObject;
  const NCCI: Integer; const Grund: Cardinal);
begin
  PostMessage (WindowHandle, WM_USER + 1, 0, 0);
end;

procedure TForm1.CapiVerbindung1MessageDump(Sender: TObject;
  const CommandID, SubCommand: Cardinal; var Daten: ReceiveDatenType);
var
  line : String;
begin
  if (CommandID <> DATA_B3) then begin
    with Sender as TCapi20Handler do begin
      line := GetCommandStr (CommandID,SubCommand);
      Memo1.Lines.Add (line);
    end;
  end;
end;

procedure TForm1.CapiVerbindung2MessageDump(Sender: TObject; const CommandID, SubCommand: Cardinal; var Daten: ReceiveDatenType);
var
  line : String;
begin
  if (CommandID <> DATA_B3) then begin
    with Sender as TCapi20Handler do begin
      line := GetCommandStr (CommandID,SubCommand);
      Memo2.Lines.Add (line);
    end;
  end;
end;

procedure TForm1.Weiterleiten1Click(Sender: TObject);
var numstr : String;
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    WeiterleitungNr := numstr;
    Form1.Caption := 'Rumfumleitung von ' + AnnahmeNr + ' nach ' + WeiterleitungNr;
  end;
end;

procedure TForm1.CapiVerbindung1Disconnect(Sender: TObject;
  const Grund: Cardinal);
begin
  if (AnnahmeOk) then
    CapiVerbindung1.EnableListen ([TELEPHONY, ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
end;

end.
